#ifndef MGLPP_TEXTURE_HPP
#define MGLPP_TEXTURE_HPP

#include "../system/vec.hpp"

extern "C" {
#include <mgl/graphics/texture.h>
}

namespace mgl {
    class Image;
    class Texture {
    public:
        struct LoadOptions {
            bool compressed;
            bool pixel_coordinates;
        };

        Texture();
        Texture(Texture &&other);
        Texture& operator=(Texture &&other);
        ~Texture();

        static Texture reference(mgl_texture ref);

        bool load_from_file(const char *filepath, const LoadOptions load_options = {false, false});
        bool load_from_image(Image &image, const LoadOptions load_options = {false, false});
        void clear();
        vec2i get_size() const;
        bool is_valid() const;

        mgl_texture* internal_texture();
    private:
        Texture(const Texture&);
        Texture& operator=(const Texture&);
    private:
        mgl_texture texture;
        bool owned = true;
    };
}

#endif /* MGLPP_TEXTURE_HPP */
